uniform sampler2D reflectionmap;
uniform sampler2D refractionmap;
uniform sampler2D normalmap;
uniform mat3 core_ModelViewNormalMatrix;

uniform float reflection_IsReflecting;
uniform float refraction_IsRefracting;

varying vec4 projCoord;
varying vec4 refractCoord;
varying vec2 texCoord1;
varying vec2 texCoord2;
varying vec3 viewdir;

void main()
{
	if(reflection_IsReflecting == 1 || refraction_IsRefracting == 1)
	{
		discard;
	}

	vec3 normal = normalize((texture2D(normalmap,texCoord1).xyz*2.0 - 1.0) + (texture2D(normalmap,texCoord2).xyz*2.0 - 1.0));
	vec3 wave = normal - vec3(0,0,1);
	normal = normalize(core_ModelViewNormalMatrix * normal);
	viewdir = normalize(viewdir);
	float seacolorfactor = abs(dot(normal,viewdir));

	vec2 reflect_coord = (projCoord.xy/projCoord.w + 1.0) * 0.5 + wave.xy * 0.1;
	vec2 refract_coord = (refractCoord.xy/refractCoord.w + 1.0) * 0.5 + wave.xy * 0.1;
	vec4 reflectioncolor = texture2D(reflectionmap,reflect_coord);
	vec4 refractioncolor = texture2D(refractionmap,refract_coord);
	
	gl_FragColor = reflectioncolor * (1-seacolorfactor) + refractioncolor * seacolorfactor;
}